/**
* Filename: Serializer.java (in org.openbandy.io)
* This is part of the OpenBandy project.

* @author Philipp Bolliger (philipp@bolliger.name)
* @version 1.0
* 
* (c) Copyright 2007, ALL RIGHTS RESERVED.
*
* TODO describe purpose and usage 
*/

package org.openbandy.io;

public interface Serializer {
	
	/** Flags that can be used to exactly specify which serializer
	 *  must process a given value.	 */
	public static final byte MODE_STREAM = 1;
	public static final byte MODE_RMS = 2;
	public static final byte MODE_DATABASE = 4;
	
	/** Per default, all seralizers are used */
	public static final byte MODE_DEFAULT = MODE_STREAM | MODE_RMS | MODE_DATABASE;
    
    /**
     * TODO comment!
     *
     * @param serializable
     * @param serializationBuffer
     */
    public void serializeObject(Serializable serializable, SerializationBuffer serializationBuffer);
    
    /**
     * TODO comment!
     *
     * @param serializable
     * @param serializationBuffer
     */
    public void deserializeObject(Serializable serializable, SerializationBuffer serializationBuffer);

}
