/**
* Filename: StorageConnection.java (in org.openbandy.io.storage)
* This is part of the OpenBandy project.

* @author Philipp Bolliger (philipp@bolliger.name)
* @version 0.8
* 
* (c) Copyright 2007, ALL RIGHTS RESERVED.
*
* Represents a connection to the actual storage, may this be the
* database or the RMS.
* 
* Its most important attribute is the isConnected() method.
*/

package org.openbandy.io.storage;

import org.openbandy.io.Serializable;


public interface StorageConnection {
    
    /**
     * TODO comment!
     * 
     * @return
     */
    public boolean connect();
    
    /**
     * TODO comment!
     * 
     * @return
     */
    public boolean isConnected();
    
    /**
     * Returns a string that allows the Storage to distinguish
     * different connections in order to avert muliple open
     * connections for the same serializer.
     * @return
     */
    public String getConnectionIdentifier();
    
    /**
     * TODO comment!
     *
     */
    public void close();
    
	/**
	 * This method inserts the <code>objectEntry</code> in the storage
	 * and returns the genereated id resp. key.
	 * 
	 * @param objectEntry
	 * @return newKey The key generated by the database while executing the INSERT.
	 */
	public int executeINSERT(ObjectEntry objectEntry);
	
	/**
	 * This method updates the <code>objectEntry</code> in the storage.
	 * 
	 * @param objectEntry
	 */
	public void executeUPDATE(ObjectEntry objectEntry);
	
	/**
	 * This method deletes the <code>serializable</code> object in the storage.
	 * 
	 * @param objectEntry
	 * @return Returns true if the <code>serializable</code> object has been deleted.
	 */
	public boolean executeDELETE(Serializable serializable);
	
}
