/**
* Filename: SmsSender.java (in org.openbandy.net.client)
* This file is part of the BandyBasics project.
*
* www.openbandy.org
*/


package org.openbandy.net.client;

import java.io.IOException;

import javax.microedition.io.Connector;
import javax.wireless.messaging.BinaryMessage;
import javax.wireless.messaging.MessageConnection;

import org.openbandy.net.MessageBroker;
import org.openbandy.service.LogService;

/**
 * TODO describe purpose and usage
 * 
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 *
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 0.1
 */
public class SmsSender {
    
    /* Network connection to other clients */
    private MessageConnection clientConnection;

    public void sendMessage(String cellPhoneNumber, byte[] message) {
        if(cellPhoneNumber != ""){
            try{
                /* open connection to client */
                String address = "sms://"+cellPhoneNumber+":"+MessageBroker.SMS_PORT;
                clientConnection = (MessageConnection)Connector.open(address);
                
                /* create binary sms message */
                BinaryMessage binaryMessage = (BinaryMessage)clientConnection.newMessage(MessageConnection.BINARY_MESSAGE);
                binaryMessage.setPayloadData(message);
                
                clientConnection.send(binaryMessage);
                clientConnection.close();
                
                LogService.info(this, "Sent SMS to "+address);
            }catch(SecurityException se){
                /* the user did not allow to send sms */
            	LogService.warn(this, "Not authorized to open connection for sms messages");
            }
            catch(IOException ioe){
            	LogService.error(this, "Could not send message", ioe);
            }
        }else{
        	LogService.warn(this, "Could not send message. No target phone number");
        }

    }

}
